Bug 868939 - Review Request: python-llfuse - Python Bindings for the low-level FUSE API
Review Request: python-llfuse - Python Bindings for the low-level FUSE API
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 868940
  Show dependency treegraph
 
Reported: 2012-10-22 10:03 EDT by Marcel Wysocki
Modified: 2012-11-15 06:46 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-11-15 06:46:57 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Marcel Wysocki 2012-10-22 10:03:08 EDT
Spec URL: http://maci.satgnu.net/rpmbuild/SPECS/python-llfuse.spec
SRPM URL: http://maci.satgnu.net/rpmbuild/SRPMS/python-llfuse-0.37.1-3.fc17.src.rpm
Description: LLFUSE is a set of Python bindings for the low level FUSE API. It requires at
least FUSE 2.8.0 and supports both Python 2.x and 3.x.
Fedora Account System Username: maci
Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=4615554
Comment 2 Mario Blättermann 2012-10-27 09:41:19 EDT
Same problem as for bug #868936: dead links.
Comment 3 Marcel Wysocki 2012-10-27 13:52:24 EDT
fixed
Comment 4 Mario Blättermann 2012-10-28 13:33:11 EDT
The source tarball contains a bundled egg-info. Please remove it before building your package (in the %prep section):

rm -rf src/llfuse.egg-info

Maybe you have to add python-setuptools to BR.

See https://fedoraproject.org/wiki/Packaging:Python_Eggs#Upstream_Eggs for more information.
Comment 5 Mario Blättermann 2012-10-28 13:53:44 EDT
BTW, Python is not needed as an explicit requirement. It will be picked up by rpm automatically.
Comment 7 Mario Blättermann 2012-10-29 17:52:42 EDT
Scratch build fails for Rawhide:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4637399

src/llfuse.c:4:20: fatal error: Python.h: No such file or directory

python-devel is missing from BR.
Comment 9 Mario Blättermann 2012-10-30 15:42:59 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4640590

$ rpmlint -i -v *
python-llfuse.src: I: checking
python-llfuse.src: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse.src: I: checking-url http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 (timeout 10 seconds)
python-llfuse.src: W: invalid-url Source0: http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 HTTP Error 404: Not Found
The value should be a valid, public HTTP, HTTPS, or FTP URL.

python-llfuse.i686: I: checking
python-llfuse.i686: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse.i686: W: private-shared-object-provides /usr/lib/python2.7/site-packages/llfuse.so llfuse.so
A shared object soname provides is provided by a file in a path from which
other packages should not directly load shared objects from.  Such shared
objects should thus not be depended on and they should not result in provides
in the containing package.  Get rid of the provides if appropriate, for
example by filtering it out during build.  Note that in some cases this may
require disabling rpmbuild's internal dependency generator.

python-llfuse.x86_64: I: checking
python-llfuse.x86_64: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse.x86_64: W: private-shared-object-provides /usr/lib64/python2.7/site-packages/llfuse.so llfuse.so()(64bit)
A shared object soname provides is provided by a file in a path from which
other packages should not directly load shared objects from.  Such shared
objects should thus not be depended on and they should not result in provides
in the containing package.  Get rid of the provides if appropriate, for
example by filtering it out during build.  Note that in some cases this may
require disabling rpmbuild's internal dependency generator.

python-llfuse-debuginfo.i686: I: checking
python-llfuse-debuginfo.i686: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse-debuginfo.x86_64: I: checking
python-llfuse-debuginfo.x86_64: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse.spec: I: checking-url http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 (timeout 10 seconds)
python-llfuse.spec: W: invalid-url Source0: http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 HTTP Error 404: Not Found
The value should be a valid, public HTTP, HTTPS, or FTP URL.

5 packages and 1 specfiles checked; 0 errors, 4 warnings.


Tarball is downloadable with wget, the typical error message for Googlecode stuff.

For the private libraries we need the same filtering as in python-apsw.
Comment 11 Mario Blättermann 2012-10-31 07:52:42 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4642480

$ rpmlint -i -v *
python-llfuse.src: I: checking
python-llfuse.src: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse.src: I: checking-url http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 (timeout 10 seconds)
python-llfuse.src: W: invalid-url Source0: http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 HTTP Error 404: Not Found
The value should be a valid, public HTTP, HTTPS, or FTP URL.

python-llfuse.i686: I: checking
python-llfuse.i686: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse.x86_64: I: checking
python-llfuse.x86_64: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse-debuginfo.i686: I: checking
python-llfuse-debuginfo.i686: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse-debuginfo.x86_64: I: checking
python-llfuse-debuginfo.x86_64: I: checking-url http://code.google.com/p/python-llfuse/ (timeout 10 seconds)
python-llfuse.spec: I: checking-url http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 (timeout 10 seconds)
python-llfuse.spec: W: invalid-url Source0: http://python-llfuse.googlecode.com/files/llfuse-0.37.1.tar.bz2 HTTP Error 404: Not Found
The value should be a valid, public HTTP, HTTPS, or FTP URL.

5 packages and 1 specfiles checked; 0 errors, 2 warnings.


No real issues anymore.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    LGPLv2+
[x] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
    The LICENSE file is still missing from %doc.

[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    047f29c2d0363766807ba21b72a68f66022eddde642e7c7f167145fa1a2b6782  llfuse-0.37.1.tar.bz2
    047f29c2d0363766807ba21b72a68f66022eddde642e7c7f167145fa1a2b6782  llfuse-0.37.1.tar.bz2.packaged

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: Development files must be in a -devel package.
[.] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[.] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


These are the Provides for the x86 package:

$ rpm -qpR python-llfuse-0*6.rpm
fuse >= 2.8.0
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
libc.so.6  
libc.so.6(GLIBC_2.0)  
libc.so.6(GLIBC_2.1.3)  
libc.so.6(GLIBC_2.2)  
libc.so.6(GLIBC_2.3)  
libc.so.6(GLIBC_2.4)  
libfuse.so.2  
libfuse.so.2(FUSE_2.4)  
libfuse.so.2(FUSE_2.5)  
libfuse.so.2(FUSE_2.6)  
libfuse.so.2(FUSE_2.8)  
libpthread.so.0  
libpthread.so.0(GLIBC_2.0)  
libpthread.so.0(GLIBC_2.3.2)  
libpython2.7.so.1.0  
librt.so.1  
librt.so.1(GLIBC_2.2)  
python(abi) = 2.7
rtld(GNU_HASH)  
rpmlib(PayloadIsXz) <= 5.2-1


Fuse appears twice, in "libfuse.so.2(FUSE_2.8)" and "fuse >= 2.8.0". The latter is an explicit requirement in the spec file. Please drop it. If rpm is able to find it automatically due to system calls during the build, it is not needed to mention it in the spec.

Moreover, add LICENSE to %doc.
Comment 13 Mario Blättermann 2012-10-31 09:59:07 EDT
OK, your package is APPROVED.

For future releases, try to build it also for Python 3, as mentioned in the package description.
Comment 14 Marcel Wysocki 2012-10-31 12:32:05 EDT
thanks, ill put python3 builds on my todo list. gotta read the wiki pages first
Comment 15 Marcel Wysocki 2012-10-31 12:34:17 EDT
New Package SCM Request
=======================
Package Name: python-llfuse
Short Description: Python Bindings for the low-level FUSE API
Owners: maci
Branches: f17 f18 el6
InitialCC:
Comment 16 Kevin Fenzi 2012-10-31 22:05:41 EDT
Git done (by process-git-requests).
Comment 17 Fedora Update System 2012-11-01 04:43:27 EDT
python-llfuse-0.37.1-9.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/python-llfuse-0.37.1-9.fc17
Comment 18 Fedora Update System 2012-11-01 04:44:38 EDT
python-llfuse-0.37.1-9.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/python-llfuse-0.37.1-9.fc18
Comment 19 Fedora Update System 2012-11-01 14:31:31 EDT
python-llfuse-0.37.1-9.fc18 has been pushed to the Fedora 18 testing repository.

Note You need to log in before you can comment on or make changes to this bug.